/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20170709

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#define YYPREFIX "yy"

#define YYPURE 0

#line 2 "cue_parser.y"
/*
 * Copyright (c) 2004, 2005, 2006, 2007, Svend Sorensen
 * Copyright (c) 2009, 2010 Jochen Keil
 * Copyright (c) 2012, 2013 Sergey Galanov
 * For license terms, see the file COPYING in this distribution.
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "config.h"

#include "cd.h"
#include "time.h"

#ifdef YY_BUF_SIZE
#undef YY_BUF_SIZE
#endif
#define YY_BUF_SIZE 16384

#define YYDEBUG 1

char fnamebuf[PARSER_BUFFER];

/* debugging */
/*int yydebug = 1;*/

extern int yylineno;
extern FILE* yyin;

const char *yyfilename;

static Cd *cd = NULL;
static Track *track = NULL;
static Track *prev_track = NULL;
static Cdtext *cdtext = NULL;
static Rem *rem = NULL;
static char *prev_filename = NULL;	/* last file in or before last track */
static char *cur_filename = NULL;	/* last file in the last track */
static char *new_filename = NULL;	/* last file in this track */

/* lexer interface */
typedef struct yy_buffer_state* YY_BUFFER_STATE;

int yylex(void);
void yyerror(const char*);
YY_BUFFER_STATE yy_scan_string(const char*);
YY_BUFFER_STATE yy_create_buffer(FILE*, int);
void yy_switch_to_buffer(YY_BUFFER_STATE);
void yy_delete_buffer(YY_BUFFER_STATE);

/* parser interface */
int yyparse(void);
Cd *cue_parse_file(FILE *fp, const char *filename);
Cd *cue_parse_string(const char*);
#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#line 62 "cue_parser.y"
typedef union {
	long ival;
	char *sval;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 90 "cue_parser.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define NUMBER 257
#define STRING 258
#define CATALOG 259
#define CDTEXTFILE 260
#define FFILE 261
#define BINARY 262
#define MOTOROLA 263
#define AIFF 264
#define WAVE 265
#define MP3 266
#define FLAC 267
#define APE 268
#define TRACK 269
#define AUDIO 270
#define MODE1_2048 271
#define MODE1_2352 272
#define MODE2_2336 273
#define MODE2_2048 274
#define MODE2_2342 275
#define MODE2_2332 276
#define MODE2_2352 277
#define TRACK_ISRC 278
#define FLAGS 279
#define PRE 280
#define DCP 281
#define FOUR_CH 282
#define SCMS 283
#define PREGAP 284
#define INDEX 285
#define POSTGAP 286
#define BOM 287
#define TITLE 288
#define PERFORMER 289
#define SONGWRITER 290
#define COMPOSER 291
#define ARRANGER 292
#define MESSAGE 293
#define DISC_ID 294
#define GENRE 295
#define TOC_INFO1 296
#define TOC_INFO2 297
#define UPC_EAN 298
#define ISRC 299
#define SIZE_INFO 300
#define DATE 301
#define COMMENT 302
#define RGENRE 303
#define REPLAYGAIN_ALBUM_GAIN 304
#define REPLAYGAIN_ALBUM_PEAK 305
#define REPLAYGAIN_TRACK_GAIN 306
#define REPLAYGAIN_TRACK_PEAK 307
#define YYERRCODE 256
typedef short YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    6,    6,    7,    8,    8,   10,   10,   10,   10,
   10,   10,   13,    9,    9,   15,   14,   14,   14,   14,
   14,   14,   14,   14,   16,   17,    1,    1,    1,    1,
    1,    1,    1,    1,   18,   18,   19,   19,   19,   19,
   19,   19,   19,   19,   19,   20,   20,    2,    2,    2,
    2,   11,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    3,    3,   12,    5,    5,
    5,    5,    5,    5,    5,
};
static const YYINT yylen[] = {                            2,
    4,    1,    0,    0,    0,    2,    3,    3,    1,    1,
    1,    2,    4,    1,    2,    3,    1,    1,    1,    1,
    1,    1,    1,    1,    0,    4,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    1,    1,    3,    3,
    3,    4,    3,    1,    2,    0,    2,    1,    1,    1,
    1,    3,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    5,    3,    1,    1,
    1,    1,    1,    1,    1,
};
static const YYINT yydefred[] = {                         0,
    2,    0,    4,    5,    0,    0,    0,    0,    0,   53,
   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,
   64,   65,   69,   70,   71,   72,   73,   74,   75,    0,
    0,    0,    6,    9,   10,   11,   14,    0,   12,    0,
    0,    0,    0,    0,   15,    0,    0,    7,    8,   24,
   17,   18,   19,   20,   21,   22,   23,    0,   52,   68,
    0,    0,    0,   46,    0,    0,    0,   37,   38,   44,
    0,   35,   13,   27,   28,   29,   30,   31,   32,   33,
   34,    0,   45,    0,    0,    0,    0,    0,    0,   36,
   26,   40,   48,   49,   50,   51,   39,   47,    0,   41,
    0,   43,    0,   42,    0,   67,
};
static const YYINT yydgoto[] = {                          2,
   82,   98,   87,   30,   31,    3,    4,    5,   32,   33,
   68,   69,   70,   58,   37,   38,   47,   71,   72,   85,
};
static const YYINT yysindex[] = {                      -283,
    0,    0,    0,    0, -182,   -2, -242, -241, -240,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -239,
 -238,    0,    0,    0,    0,    0,    0, -248,    0,   13,
   16, -253,   17,   18,    0, -228, -254,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   23,    0,    0,
 -144,   45, -198,    0, -201, -196, -201,    0,    0,    0,
 -254,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   52,    0,   53,  -10,    7,   54, -201,   56,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -189,    0,
   59,    0,   12,    0, -186,    0,
};
static const YYINT yyrindex[] = {                      -202,
    0,    0,    0,    0, -197,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    5,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    6,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   63,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,
};
static const YYINT yygindex[] = {                         0,
    0,    0,  -66,    0,    0,    0,    0,    0,    0,    0,
   70,   71,   75,    0,   49,    0,    0,    0,   11,    0,
};
#define YYTABLESIZE 275
static const YYINT yytable[] = {                         97,
   89,   62,   50,    1,    1,   16,    9,   39,   51,   52,
   53,   54,   55,   56,   57,   40,   41,   42,   43,   44,
   46,  101,   48,   63,   64,   49,   59,   60,   61,   65,
   66,   67,   73,   10,   11,   12,   13,   14,   15,   16,
   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,
   27,   28,   29,    3,   83,   86,    3,    3,    3,   84,
   88,   91,   92,  100,   99,  102,    3,  103,  104,  105,
  106,   25,   66,    6,   34,   35,    7,    8,    9,   36,
   45,   90,    0,    0,    0,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,   10,   11,   12,   13,   14,
   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
   25,   26,   27,   28,   29,   74,   75,   76,   77,   78,
   79,   80,   81,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   93,
   94,   95,   96,   25,   16,
};
static const YYINT yycheck[] = {                         10,
   67,  256,  256,  287,    0,    0,  261,   10,  262,  263,
  264,  265,  266,  267,  268,  258,  258,  258,  258,  258,
  269,   88,   10,  278,  279,   10,   10,   10,  257,  284,
  285,  286,   10,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  256,   10,  257,  259,  260,  261,  258,
  257,   10,   10,   10,   58,   10,  269,  257,   10,   58,
  257,  269,   10,  256,    5,    5,  259,  260,  261,    5,
   32,   71,   -1,   -1,   -1,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
  303,  304,  305,  306,  307,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
  303,  304,  305,  306,  307,  270,  271,  272,  273,  274,
  275,  276,  277,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
  281,  282,  283,  269,  269,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 307
#define YYUNDFTOKEN 330
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,"'\\n'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"':'",0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"NUMBER","STRING",
"CATALOG","CDTEXTFILE","FFILE","BINARY","MOTOROLA","AIFF","WAVE","MP3","FLAC",
"APE","TRACK","AUDIO","MODE1_2048","MODE1_2352","MODE2_2336","MODE2_2048",
"MODE2_2342","MODE2_2332","MODE2_2352","TRACK_ISRC","FLAGS","PRE","DCP",
"FOUR_CH","SCMS","PREGAP","INDEX","POSTGAP","BOM","TITLE","PERFORMER",
"SONGWRITER","COMPOSER","ARRANGER","MESSAGE","DISC_ID","GENRE","TOC_INFO1",
"TOC_INFO2","UPC_EAN","ISRC","SIZE_INFO","DATE","COMMENT","RGENRE",
"REPLAYGAIN_ALBUM_GAIN","REPLAYGAIN_ALBUM_PEAK","REPLAYGAIN_TRACK_GAIN",
"REPLAYGAIN_TRACK_PEAK",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : cuefile",
"cuefile : maybe_bom new_cd global_statements track_list",
"maybe_bom : BOM",
"maybe_bom :",
"new_cd :",
"global_statements :",
"global_statements : global_statements global_statement",
"global_statement : CATALOG STRING '\\n'",
"global_statement : CDTEXTFILE STRING '\\n'",
"global_statement : cdtext",
"global_statement : rem",
"global_statement : track_data",
"global_statement : error '\\n'",
"track_data : FFILE STRING file_format '\\n'",
"track_list : track",
"track_list : track_list track",
"track : new_track track_def track_statements",
"file_format : BINARY",
"file_format : MOTOROLA",
"file_format : AIFF",
"file_format : WAVE",
"file_format : MP3",
"file_format : FLAC",
"file_format : APE",
"file_format : error",
"new_track :",
"track_def : TRACK NUMBER track_mode '\\n'",
"track_mode : AUDIO",
"track_mode : MODE1_2048",
"track_mode : MODE1_2352",
"track_mode : MODE2_2336",
"track_mode : MODE2_2048",
"track_mode : MODE2_2342",
"track_mode : MODE2_2332",
"track_mode : MODE2_2352",
"track_statements : track_statement",
"track_statements : track_statements track_statement",
"track_statement : cdtext",
"track_statement : rem",
"track_statement : FLAGS track_flags '\\n'",
"track_statement : TRACK_ISRC STRING '\\n'",
"track_statement : PREGAP time '\\n'",
"track_statement : INDEX NUMBER time '\\n'",
"track_statement : POSTGAP time '\\n'",
"track_statement : track_data",
"track_statement : error '\\n'",
"track_flags :",
"track_flags : track_flags track_flag",
"track_flag : PRE",
"track_flag : DCP",
"track_flag : FOUR_CH",
"track_flag : SCMS",
"cdtext : cdtext_item STRING '\\n'",
"cdtext_item : TITLE",
"cdtext_item : PERFORMER",
"cdtext_item : SONGWRITER",
"cdtext_item : COMPOSER",
"cdtext_item : ARRANGER",
"cdtext_item : MESSAGE",
"cdtext_item : DISC_ID",
"cdtext_item : GENRE",
"cdtext_item : TOC_INFO1",
"cdtext_item : TOC_INFO2",
"cdtext_item : UPC_EAN",
"cdtext_item : ISRC",
"cdtext_item : SIZE_INFO",
"time : NUMBER",
"time : NUMBER ':' NUMBER ':' NUMBER",
"rem : rem_item STRING '\\n'",
"rem_item : DATE",
"rem_item : COMMENT",
"rem_item : RGENRE",
"rem_item : REPLAYGAIN_ALBUM_GAIN",
"rem_item : REPLAYGAIN_ALBUM_PEAK",
"rem_item : REPLAYGAIN_TRACK_GAIN",
"rem_item : REPLAYGAIN_TRACK_PEAK",

};
#endif

int      yydebug;
int      yynerrs;

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#define YYINITSTACKSIZE 200

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
/* variables for the parser stack */
static YYSTACKDATA yystack;
#line 340 "cue_parser.y"

/* lexer interface */

void yyerror (const char *s)
{
	fprintf(stderr, "%d: %s (in %s)\n", yylineno, s, yyfilename);
}

Cd *cue_parse_file(FILE *fp, const char *filename)
{
	YY_BUFFER_STATE buffer = NULL;

	yyin = fp;
	yyfilename = filename;
	yylineno = 1;

	buffer = yy_create_buffer(yyin, YY_BUF_SIZE);

	yy_switch_to_buffer(buffer);

	if (0 == yyparse())
	{
		yy_delete_buffer(buffer);
		return cd;
	}

	yy_delete_buffer(buffer);
	return NULL;
}

Cd *cue_parse_string(const char* string)
{
	YY_BUFFER_STATE buffer = NULL;

	buffer = yy_scan_string(string);
	yylineno = 1;

	if (0 == yyparse())
	{
		yy_delete_buffer(buffer);
		return cd;
	}

	yy_delete_buffer(buffer);

	return NULL;
}
#line 493 "cue_parser.c"

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yym = 0;
    yyn = 0;
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        yychar = YYLEX;
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;

    YYERROR_CALL("syntax error");

    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);

    switch (yyn)
    {
case 4:
#line 149 "cue_parser.y"
	{
		cd = cd_init();
		cdtext = cd_get_cdtext(cd);
		rem = cd_get_rem(cd);
	}
break;
case 7:
#line 162 "cue_parser.y"
	{ cd_set_catalog(cd, yystack.l_mark[-1].sval); }
break;
case 8:
#line 163 "cue_parser.y"
	{ cd_set_cdtextfile(cd, yystack.l_mark[-1].sval); }
break;
case 13:
#line 171 "cue_parser.y"
	{
		if (NULL != new_filename) {
			yyerror("too many files specified\n");
		}
		new_filename = strncpy(fnamebuf, yystack.l_mark[-2].sval, sizeof(fnamebuf));
		new_filename[strlen(new_filename)] = '\0';
	}
break;
case 25:
#line 201 "cue_parser.y"
	{
		/* save previous track, to later set length */
		prev_track = track;

		track = cd_add_track(cd);
		cdtext = track_get_cdtext(track);
		rem = track_get_rem(track);

		cur_filename = new_filename;
		if (NULL != cur_filename)
			prev_filename = cur_filename;

		if (NULL == prev_filename)
			yyerror("no file specified for track");
		else
			track_set_filename(track, prev_filename);

		new_filename = NULL;
	}
break;
case 26:
#line 223 "cue_parser.y"
	{
		track_set_mode(track, yystack.l_mark[-1].ival);
	}
break;
case 40:
#line 248 "cue_parser.y"
	{ track_set_isrc(track, yystack.l_mark[-1].sval); }
break;
case 41:
#line 249 "cue_parser.y"
	{ track_set_zero_pre(track, yystack.l_mark[-1].ival); }
break;
case 42:
#line 250 "cue_parser.y"
	{
		int i = track_get_nindex(track);
		long prev_length;

		/* Handle non-compliant cuesheets, i.e. multi-file sheets where index 0
		 * is at the end of the previous track file
		 * In such cases we have a FILE occurence between index 0 and index 1.
		 * Just discard that index 0 */
		if (NULL != new_filename && 1 == i) {
			/* Set correct file name */
			track_set_filename(track, new_filename);
			new_filename = NULL;

			/* Discard indices */
			track_remove_indices(track);
			i = 0;
		}

		if (0 == i) {
			/* first index */
			track_set_start(track, yystack.l_mark[-1].ival);

			if (NULL != prev_track && NULL == cur_filename) {
				/* track shares file with previous track */
				prev_length = yystack.l_mark[-1].ival - track_get_start(prev_track);
				track_set_length(prev_track, prev_length);
			}
		}

		for (; i <= yystack.l_mark[-2].ival; i++)
			track_add_index(track, \
			track_get_zero_pre(track) + yystack.l_mark[-1].ival \
			- track_get_start(track));
	}
break;
case 43:
#line 284 "cue_parser.y"
	{ track_set_zero_post(track, yystack.l_mark[-1].ival); }
break;
case 47:
#line 291 "cue_parser.y"
	{ track_set_flag(track, yystack.l_mark[0].ival); }
break;
case 52:
#line 302 "cue_parser.y"
	{ cdtext_set (yystack.l_mark[-2].ival, yystack.l_mark[-1].sval, cdtext); }
break;
case 67:
#line 323 "cue_parser.y"
	{ yyval.ival = time_msf_to_frame(yystack.l_mark[-4].ival, yystack.l_mark[-2].ival, yystack.l_mark[0].ival); }
break;
case 68:
#line 327 "cue_parser.y"
	{ rem_set(yystack.l_mark[-2].ival, yystack.l_mark[-1].sval, rem); }
break;
#line 811 "cue_parser.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            yychar = YYLEX;
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    YYERROR_CALL("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
